SystemOrganization addCategory: #'Glamour-Morphic-Renderer'!
SystemOrganization addCategory: #'Glamour-Morphic-Renderer-Spotter'!

GLMRenderer subclass: #GLMMorphicRenderer
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicRenderer commentStamp: 'tg 4/1/2010 07:11' prior: 0!
This is the class responsible for the binding to Morphic.

| browser |
browser := GLMTabulator new.
browser column: #one; column: #two.

browser transmit to: #one; andShow: [:a | a list.].
browser transmit to: #two; from: #one; andShow: [ :a |
	a text.].
browser openOn: #(a b c d)!

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'cyrilledelaunay 4/1/2011 16:25'!
open: aRenderable
	window := GLMMorphicWindowRenderer render: aRenderable from: self.
	^ window openInWorld! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderAccordionCompositePresentation: aCompositePresentation
	^ GLMMorphicAccordionRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:51'!
renderAccumulator: aBrowser 
	^ GLMMorphicAccumulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering actions' stamp: 'EstebanLorenzano 4/20/2012 16:14'!
renderAction: anAction
	^(UITheme current 
		newButtonIn: nil 
		for: anAction
		getState: nil
		action: #morphicActOn:
		arguments: {}
		getEnabled: nil
		label: (AlphaImageMorph new image: anAction icon)
		help: anAction title)
		valueOfProperty: #noBorder ifAbsentPut: [true]; "this is a hack to tell the GLMUITheme to not draw the border and the fill"
		valueOfProperty: #noFill ifAbsentPut: [true];
		setProperty: #wantsKeyboardFocusNavigation toValue: false; "to disable the focus"
		yourself! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'EstebanLorenzano 4/20/2012 16:14'!
renderActionListPresentation: anActionListPresentation 
	^GLMMorphicActionListRenderer render: anActionListPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'cyrilledelaunay 6/7/2011 17:01'!
renderDashboard: aBrowser 
	^ GLMMorphicDashboardRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 9/3/2010 13:56'!
renderDiffPresentation: aPresentation
	^ GLMMorphicDiffRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 6/29/2012 09:47'!
renderDropDownListPresentation: aDropListPresentation
	^ GLMMorphicDropDownRenderer render: aDropListPresentation from: self	! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 2/4/2011 18:10'!
renderDynamicPresentation: aPresentation
	^ GLMMorphicDynamicRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 1/2/2011 18:58'!
renderExpander: aBrowser 
	^ GLMMorphicExpanderRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 4/12/2011 10:33'!
renderEyeSeePresentation: aPresentation
	^ GLMMorphicEyeSeeRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 2/15/2011 18:07'!
renderFinder: aBrowser 
	^ aBrowser hasFixedSizePanes 
		ifTrue: [GLMMorphicFixedPanesFinderRenderer render: aBrowser from: self]
		ifFalse: [GLMMorphicVariablePanesFinderRenderer render: aBrowser from: self]! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 1/20/2011 21:53'!
renderInputPresentation: aPresentation 
	
	| morph |
	self flag: 'hook the cuis editor'.
	morph := GLMMorphic containerMorph.
	^ morph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 7/1/2011 23:15'!
renderLabelPresentation: aLabelPresentation 
	^ GLMMorphicLabelRenderer render: aLabelPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:14'!
renderListPresentation: aListPresentation 
	^ GLMMorphicListRenderer render: aListPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:12'!
renderListingPresentation: aPresentation 
	^ GLMMorphicListingRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 1/13/2011 13:46'!
renderMagrittePresentation: aMagrittePresentation 
	^ GLMMorphicMagritteRenderer render: aMagrittePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/23/2010 00:22'!
renderMondrianPresentation: aPresentation
	^ GLMMorphicMondrianRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'EstebanLorenzano 10/6/2011 22:29'!
renderMorphPresentation: aMorphPresentation 
	^ GLMMorphicMorphRenderer render: aMorphPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 21:51'!
renderPane: aPane 
	^ GLMMorphicPaneRenderer render: aPane from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 5/5/2012 14:41'!
renderRoassalPresentation: aPresentation
	^ GLMMorphicRoassalRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 8/29/2011 23:51'!
renderSmalltalkCodePresentation: aSmalltalkCodePresentation 
	^ GLMMorphicSmalltalkCodeRenderer render: aSmalltalkCodePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderStackedVerticallyCompositePresentation: aCompositePresentation
	^ GLMMorphicVerticallyStackedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderStacker: aBrowser 
	^ GLMMorphicStackerRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:33'!
renderTabbedCompositePresentation: aCompositePresentation
	^ GLMMorphicTabbedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:15'!
renderTablePresentation: aPresentation 
	^ GLMMorphicTableRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderTabulator: aBrowser 
	^ GLMMorphicTabulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 20:22'!
renderTextPresentation: aTextPresentation 
	^ GLMMorphicTextRenderer render: aTextPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:16'!
renderTreePresentation: aPresentation 
	^ GLMMorphicTreeRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'cyrilledelaunay 5/5/2011 12:03'!
renderValidator: aBrowser 

	| tmpValidatorRenderer |
	tmpValidatorRenderer :=  GLMMorphicValidatorRenderer new.
	aBrowser  setSpecificAnnouncementActionsTo: tmpValidatorRenderer.  
	^ tmpValidatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 4/12/2011 13:49'!
renderWizard: aGLMWizard

	|tmpRenderer|
	tmpRenderer :=  GLMMorphicWizardRenderer new.
	aGLMWizard  setSpecificAnnouncementActionsTo: tmpRenderer.  
	^ (tmpRenderer renderer: self) render: aGLMWizard! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 5/18/2012 22:29'!
renderWrapper: aBrowser 
	^ GLMMorphicWrapperRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window
	^ window! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window: anObject
	window := anObject! !

Notification subclass: #GLMSingleSpotterRequest
	instanceVariableNames: 'prompt default assisted searchBlock labelBlock iconBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMSingleSpotterRequest classSide methodsFor: 'utilities' stamp: 'ML 2/26/2011 15:02'!
substring: testString matches: aString caseSensitive: aBoolean
	"Checks if a testString is a substring of aString. The matching parts do not necessarily need to be consecutive, for example 'egli' matches 'renggli'."

	| index |
	index := 0.
	testString do: [ :char |
		index := aString
			findString: (String with: char)
			startingAt: index + 1
			caseSensitive: aBoolean.
		index = 0
			ifTrue: [ ^ false ] ].
	^ true! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
assisted
	^ assisted! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
assisted: aBoolean
	"A boolean indicating that the typing of the user is assisted but not constrained."
	
	assisted := aBoolean! !

!GLMSingleSpotterRequest methodsFor: 'configuration' stamp: 'ML 2/26/2011 15:02'!
collection: aCollection
	self collection: aCollection caseSensitive: false! !

!GLMSingleSpotterRequest methodsFor: 'configuration' stamp: 'ML 2/26/2011 15:02'!
collection: aCollection caseSensitive: aBoolean
	"Configure this completion dialog with aCollection and match the elements case sensitive if aBoolean is true. Display the complete list if the filter is empty."

	self searchBlock: [ :value |
		value isEmpty
			ifTrue: [ aCollection ]
			ifFalse: [
				aCollection select: [ :each |
					self class
						substring: value
						matches: (self labelFor: each)
						caseSensitive: aBoolean ] ] ]! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
default
	^ default! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
default: aString
	"The default string initially used for filtering."
	
	default := aString! !

!GLMSingleSpotterRequest methodsFor: 'initialize-release' stamp: 'TudorGirba 10/26/2011 16:01'!
defaultAction
	^(GLMMorphicSingleSpotter openOn: self) answer! !

!GLMSingleSpotterRequest methodsFor: 'dispatching' stamp: 'ML 2/26/2011 15:02'!
handleWith: anObject
	^ anObject handleCompletionRequest: self! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
iconBlock
	^ iconBlock! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
iconBlock: aOneArgumentBlock
	"A one argument block answering the icon symbol for a given element."
	
	iconBlock := aOneArgumentBlock! !

!GLMSingleSpotterRequest methodsFor: 'querying' stamp: 'ML 2/26/2011 15:02'!
iconFor: anObject
	^ iconBlock value: anObject! !

!GLMSingleSpotterRequest methodsFor: 'initialization' stamp: 'ML 2/26/2011 15:02'!
initialize
	super initialize.
	prompt := 'Completion Request'.
	default := String new.
	assisted := false.
	searchBlock := [ :value | #() ].
	labelBlock := [ :value | value asString ].
	iconBlock := [ :value | nil ]! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
labelBlock
	^ labelBlock! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
labelBlock: aOneArgumentBlock
	"A one argument block answering the string for a given element."
	
	labelBlock := aOneArgumentBlock! !

!GLMSingleSpotterRequest methodsFor: 'querying' stamp: 'ML 2/26/2011 15:02'!
labelFor: anObject
	^ labelBlock value: anObject! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:56'!
name
	^self prompt! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
prompt
	^ prompt! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
prompt: aString
	"A string with the title for this request."
	
	prompt := aString! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
searchBlock
	^ searchBlock! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
searchBlock: aOneArgumentBlock
	"A one argument block returning the elements for the given filter."
	
	searchBlock := aOneArgumentBlock! !

!GLMSingleSpotterRequest methodsFor: 'querying' stamp: 'ML 2/26/2011 15:02'!
valuesFor: anObject
	^ searchBlock value: anObject! !

Notification subclass: #GLMSpotterRequest
	instanceVariableNames: 'requests prompt default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'ML 2/26/2011 16:07'!
add: aRequest
	requests add: aRequest ! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:20'!
default
	^ default! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:20'!
default: anObject
	default := anObject! !

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'TudorGirba 2/27/2011 15:25'!
defaultAction
	^(GLMMorphicSpotter openOn: self) answer! !

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'ML 2/26/2011 16:10'!
handleWith: anObject
	^ anObject handleCompletionRequest: self! !

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'ML 2/26/2011 16:08'!
initialize
	super initialize.
	requests := OrderedCollection new.! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:19'!
prompt
	^ prompt! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:19'!
prompt: anObject
	prompt := anObject! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:29'!
requests
	^requests ! !

!GLMDashboardExtentStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:27'!
initializeContainer: aPanelMorph
	
	^ self subclassResponsibility ! !

!GLMDashboardExtentStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:27'!
initializeFirstColumn: aPanelMorph
	
	^ self subclassResponsibility ! !

!GLMDashboardExtentStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:10'!
initializePane: aMorphPane
	
	^ self subclassResponsibility ! !

!GLMDashboardExtentStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:27'!
initializeSecondColumn: aPanelMorph
	
	^ self subclassResponsibility ! !

!GLMSpawnBrowserAction methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 8/9/2011 13:57'!
morphicActOn: aPresentation

	^ (self actOn: aPresentation) open! !

!GLMAction methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 8/9/2011 13:56'!
morphicActOn: aPresentation

	^ self actOn: aPresentation! !

GLMAction subclass: #GLMMorphicAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAction commentStamp: '<historical>' prior: 0!
A GLMMorphicAction is special GLMAction that is only active when rendering Glamour browsers with Morphic.!

!GLMMorphicAction methodsFor: 'testing' stamp: 'tg 9/24/2010 15:36'!
worksWithMorphic
	^ true! !

!GLMFillWidthAndHeightStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:31'!
initializeContainer: aPanelMorph
	
	aPanelMorph 
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.! !

!GLMFillWidthAndHeightStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:31'!
initializeFirstColumn: aPanelMorph
	
	aPanelMorph 
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!GLMFillWidthAndHeightStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:14'!
initializePane: aMorphPane
	
	aMorphPane
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!GLMFillWidthAndHeightStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:30'!
initializeSecondColumn: aPanelMorph
	
	aPanelMorph 
		hResizing: #spaceFill;
		vResizing: #spaceFill.! !

!GLMRigidStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:28'!
initializeContainer: aPanelMorph
	
	aPanelMorph 
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.! !

!GLMRigidStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:28'!
initializeFirstColumn: aPanelMorph
	
	aPanelMorph 
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.! !

!GLMRigidStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:13'!
initializePane: aMorphPane
	
	aMorphPane
		hResizing: #rigid;
		vResizing: #rigid.! !

!GLMRigidStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:28'!
initializeSecondColumn: aPanelMorph
	
	aPanelMorph 
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.! !

DialogWindow subclass: #GLMMorphicSingleSpotter
	instanceVariableNames: 'textMorph text listMorph listValues listLabels listIndex answer parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMMorphicSingleSpotter classSide methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:05'!
on: aRequest
	^ self basicNew initializeOn: aRequest! !

!GLMMorphicSingleSpotter classSide methodsFor: 'instance creation' stamp: 'MirceaLungu 2/26/2011 17:59'!
on: aRequest parent: parent
	^ self basicNew initializeOn: aRequest parent: parent! !

!GLMMorphicSingleSpotter classSide methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:05'!
openOn: aRequest
	^ UITheme builder openModal: (self on: aRequest)! !

!GLMMorphicSingleSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:05'!
answer
	"Answer the result of the dialog or nil, if this dialog has been cancelled."
	
	^ answer! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
arrowKey: anEvent from: aMorph
	"Ignore this request."! !

!GLMMorphicSingleSpotter methodsFor: 'actions' stamp: 'ML 2/26/2011 17:05'!
cancel
	answer := nil.
	^ super cancel! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
clickIconAt: anInteger
	"Ignore this request."! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
defaultFocusMorph
	^ textMorph! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'MirceaLungu 2/26/2011 18:10'!
deselect
	self listIndex: 0.  ! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
doubleClick
	self ok! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
editorKeyStroke: anEvent
	anEvent keyCharacter = Character arrowDown ifTrue: [
		self listIndex: (self listIndex + 1 min: listValues size).
		^ true ].
	anEvent keyCharacter = Character arrowUp ifTrue: [
		self listIndex: (self listIndex - 1 max: 1). 
		^ true ].
	^ false! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'TudorGirba 10/25/2011 17:25'!
iconAt: anIndex
	^ model ifNotNil: [model iconFor: (listValues at: anIndex ifAbsent: [ ^ nil ])]! !

!GLMMorphicSingleSpotter methodsFor: 'initialization' stamp: 'ML 2/26/2011 17:05'!
initializeOn: aRequest
	model := aRequest.
	listValues := listLabels := #().
	listIndex := 0.
	self initialize.
	self title: aRequest prompt.
	self text: aRequest default
! !

!GLMMorphicSingleSpotter methodsFor: 'initialization' stamp: 'MirceaLungu 2/26/2011 18:05'!
initializeOn: aRequest parent: theParent
	parent := theParent.
	self initializeOn: aRequest.
! !

!GLMMorphicSingleSpotter methodsFor: 'testing' stamp: 'ML 2/26/2011 17:05'!
isAssisted
	^ self model assisted! !

!GLMMorphicSingleSpotter methodsFor: 'testing' stamp: 'ML 2/26/2011 17:05'!
isEnabled
	^ self model assisted
		ifTrue: [ self text isEmptyOrNil not ]
		ifFalse: [ self listIndex > 0 ]! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listIndex
	^ listIndex! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'MirceaLungu 2/26/2011 18:09'!
listIndex: anInteger
	anInteger isZero not ifTrue: [
		parent selectionIn: self.].
	listIndex = anInteger
		ifTrue: [ ^ self ].
	listIndex := anInteger.
	self listSelection ifNotNil: [ :selection |
		self isAssisted ifTrue: [ 
			text := self model labelFor: self listSelection.
			self changed: #text ] ].
	self changed: #listIndex; changed: #isEnabled! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listLabels
	^ listLabels! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listSelection
	^ listValues at: self listIndex ifAbsent: [ nil ]! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'MirceaLungu 2/26/2011 18:04'!
listSelection: anObject

	self listIndex: (listValues indexOf: anObject ifAbsent: [ 0 ])! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listValues
	^ listValues! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listValues: aCollection
	| previous |
	previous := self listSelection.
	listValues := aCollection asArray.
	listLabels := listValues
		collect: [ :each | model labelFor: each ].
	self changed: #listLabels; listSelection: previous! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newContentMorph
	^ (self newColumn: { self newTextMorph. self newListMorph })
		minWidth: 320;
		minHeight: 200;
		yourself! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'TudorGirba 10/26/2011 16:04'!
newListMorph
	listMorph := PluggableListMorph
		on: self
		list: #listLabels
		selected: #listIndex
		changeSelected: #listIndex:.
	listMorph
		borderStyle: (self theme listNormalBorderStyleFor: listMorph);
		color: (self theme listNormalFillStyleFor: listMorph);
		cornerStyle: self preferredCornerStyle;
		doubleClickSelector: #doubleClick;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		autoDeselect: false.
	^ listMorph! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newOKButton
	^ self newOKButtonFor: self getEnabled: #isEnabled! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newTextMorph
	textMorph := self
		newTextEntryFor: self
		getText: #text
		setText: #text:
		help: nil.
	textMorph
		autoAccept: true;
		selectAll.
	textMorph textMorph
		on: #keyStroke send: #editorKeyStroke: to: self.
	^ textMorph! !

!GLMMorphicSingleSpotter methodsFor: 'actions' stamp: 'ML 2/26/2011 17:05'!
ok
	answer := self model assisted
		ifTrue: [ self text ]
		ifFalse: [ self listSelection ].
	^ super ok! !

!GLMMorphicSingleSpotter methodsFor: 'accessing' stamp: 'MirceaLungu 2/26/2011 17:58'!
parent
	^ parent! !

!GLMMorphicSingleSpotter methodsFor: 'accessing' stamp: 'MirceaLungu 2/26/2011 17:58'!
parent: anObject
	parent := anObject! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-text' stamp: 'ML 2/26/2011 17:05'!
text
	^ text! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-text' stamp: 'ML 2/26/2011 17:05'!
text: aString
	text = aString
		ifTrue: [ ^ self ].
	text := aString.
	self listValues: (self model valuesFor: text).
	self isAssisted ifFalse: [
		self listIndex: (self listLabels size = 1
			ifTrue: [ 1 ]
			ifFalse: [ self listLabels findFirst: [ :each | each sameAs: text ] ]) ].
	self changed: #text; changed: #isEnabled! !

DialogWindow subclass: #GLMMorphicSpotter
	instanceVariableNames: 'textMorph text answer childrenMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMMorphicSpotter classSide methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:15'!
on: aRequest
	^ self basicNew initializeOn: aRequest! !

!GLMMorphicSpotter classSide methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:15'!
openOn: aRequest
	^ UITheme builder openModal: (self on: aRequest)! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
answer
	^ answer! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
answer: anObject
	answer := anObject! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
childrenMorphs
	^ childrenMorphs! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
childrenMorphs: anObject
	childrenMorphs := anObject! !

!GLMMorphicSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:21'!
editorKeyStroke: anEvent
"	anEvent keyCharacter = Character arrowDown ifTrue: [
		self listIndex: (self listIndex + 1 min: listValues size).
		^ true ].
	anEvent keyCharacter = Character arrowUp ifTrue: [
		self listIndex: (self listIndex - 1 max: 1). 
		^ true ]."
	^ false! !

!GLMMorphicSpotter methodsFor: 'initialization' stamp: 'ML 2/26/2011 17:18'!
initialize 
	childrenMorphs := OrderedCollection new.
	super initialize! !

!GLMMorphicSpotter methodsFor: 'initialization' stamp: 'ML 2/26/2011 17:16'!
initializeOn: aRequest
	model := aRequest.
	self initialize.
	self title: aRequest prompt.
	self text: aRequest default
! !

!GLMMorphicSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:21'!
newContentMorph
	^ (self newColumn: 
			((OrderedCollection with: self newTextMorph) addAll: self newListMorphs; yourself) )
		minWidth: 320;
		minHeight: 200;
		yourself! !

!GLMMorphicSpotter methodsFor: 'morphic' stamp: 'TudorGirba 2/27/2011 15:25'!
newListMorphs
	| list |
	self model requests do: [:each | 
		list := (GLMMorphicSingleSpotter on: each parent: self).
		self childrenMorphs add: list ].
	^ childrenMorphs collect: #newListMorph! !

!GLMMorphicSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:13'!
newTextMorph
	textMorph := self
		newTextEntryFor: self
		getText: #text
		setText: #text:
		help: nil.
	textMorph
		autoAccept: true;
		selectAll.
	textMorph textMorph
		on: #keyStroke send: #editorKeyStroke: to: self.
	^ textMorph! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'MirceaLungu 2/26/2011 18:14'!
ok
	| nonEmpty |
	nonEmpty := (self childrenMorphs select: [:e| e listIndex isZero not]).
	nonEmpty size = 1 ifTrue: [
			answer := nonEmpty first listSelection 
		] .
	
	
	^ super ok! !

!GLMMorphicSpotter methodsFor: 'callbacks' stamp: 'MirceaLungu 2/26/2011 18:10'!
selectionIn: singleSpotlight

	(self childrenMorphs reject: [:e| e = singleSpotlight] ) do: [:e| 
			e deselect.
		]! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
text
	^ text! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:14'!
text: aString
	text = aString
		ifTrue: [ ^ self ].
	text := aString.
	self childrenMorphs do: [:each | each text: aString ].
	self changed: #text; changed: #isEnabled! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:07'!
textMorph
	^ textMorph! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:07'!
textMorph: anObject
	textMorph := anObject! !

!GLMFillWidthStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 15:21'!
initializeContainer: aPanelMorph
	
	aPanelMorph 
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.! !

!GLMFillWidthStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:29'!
initializeFirstColumn: aPanelMorph
	
	aPanelMorph 
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.! !

!GLMFillWidthStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:12'!
initializePane: aMorphPane
	
	aMorphPane
		hResizing: #spaceFill;
		vResizing: #rigid.! !

!GLMFillWidthStrategy methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 5/20/2011 11:29'!
initializeSecondColumn: aPanelMorph
	
	aPanelMorph 
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.! !

TestCase subclass: #GLMMorphicSpotterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMMorphicSpotterTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 6/1/2012 00:29'!
testCreation
	| composite classRequest methodRequest thirdRequest |
	composite  := GLMSpotterRequest new.

	classRequest := GLMSingleSpotterRequest new 
			prompt: 'Find Class';
			searchBlock: [ :string | Smalltalk allClassesAndTraits select: [:each | string, '*' match: each name] ];
			labelBlock: [ :class | class name ]";
			iconBlock: [ :class | class browserIcon ]".

	methodRequest := GLMSingleSpotterRequest new 
			prompt: 'Object Selectors';
			searchBlock: [ :string | Object selectors select: [:e| string, '*' match: e asString] ];
			labelBlock: [ :e | e ].

	thirdRequest := GLMSingleSpotterRequest new 
			prompt: 'Other Selectors';
			searchBlock: [ :string | Class selectors select: [:e| string, '*' match: e asString] ];
			labelBlock: [ :e | e ].
			
	(composite 
		add: classRequest;
		add: methodRequest;
		add: thirdRequest;
				signal) inspect.! !

Object subclass: #GLMMorphicWidgetRenderer
	instanceVariableNames: 'renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWidgetRenderer commentStamp: '<historical>' prior: 0!
This is a helper class that is supposed to be subclassed for each rendering logic of a specific morph. For example, there will be a TreeRenderer, a TextRenderer etc!

GLMMorphicWidgetRenderer subclass: #GLMMorphicActionListRenderer
	instanceVariableNames: 'labelMorph container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicActionListRenderer classSide methodsFor: 'defaults' stamp: 'EstebanLorenzano 12/12/2011 20:05'!
defaultWidth 
	^100! !

!GLMMorphicActionListRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 12/12/2011 22:00'!
actOnPresentationUpdated: ann
	container removeAllMorphs.
	container addMorphBack: (self morphFrom: ann presentation)! !

!GLMMorphicActionListRenderer methodsFor: 'private' stamp: 'EstebanLorenzano 12/12/2011 19:40'!
buttonMorph: aModel
	^UITheme current 
		newButtonIn: nil 
		for: aModel 
		getState: nil
		action: #execute
		arguments: nil 
		getEnabled: nil 
		label: aModel buttonLabel
		help: nil! !

!GLMMorphicActionListRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 12/12/2011 21:47'!
morphFrom: anActionListPresentation 
	| container buttonModel button bounds |
	
	container := self rectangleMorph.
	
	anActionListPresentation allActions do: [ :each | 
		buttonModel := GLMButtonModel new.
		buttonModel glamourPresentation: anActionListPresentation.
		buttonModel glamourAction: each.

		button := self buttonMorph: buttonModel.
		container addMorphBack: button.
		button width: self class defaultWidth ].
	
	^ container! !

!GLMMorphicActionListRenderer methodsFor: 'private' stamp: 'EstebanLorenzano 12/12/2011 20:04'!
rectangleMorph 
	^RectangleMorph new
		borderWidth: 0;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellPositioning: #topLeft;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		listDirection: #leftToRight;
		listCentering: #bottomRight;
		wrapCentering: #bottomRight;
		cellInset: 5;
		yourself! !

!GLMMorphicActionListRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 12/12/2011 21:48'!
render: anActionListPresentation
	container := GLMMorphic containerMorph. 
	container 
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #spaceFill.

	container addMorphBack: (self morphFrom: anActionListPresentation).
	
	anActionListPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	
	^container ! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicBrowserRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicBrowserRenderer subclass: #GLMMorphicAccumulatorRenderer
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:25'!
actOnPaneAdded: ann 
	tabs 
		addLazyPage: (GLMMorphicPaneWithoutTitleRenderer new render: ann pane) 
		label: (self titleOrIconOf: ann pane presentations in: tabs)
		toolbar: nil
		collapsable: true.
	tabs selectedPageIndex: tabs pages size! !

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 10:50'!
actOnPaneSelected: anAnnouncement
	tabs selectedPageIndex: anAnnouncement position! !

!GLMMorphicAccumulatorRenderer methodsFor: 'as yet unclassified' stamp: 'TudorGirba 7/23/2011 20:26'!
removePage: aPage
	| removedPageIndex |
	removedPageIndex := self pages indexOf: aPage.
	self announcer suspendAllWhile: [ super removePage: aPage ].
	self announcer announce: 
		(LazyTabPageRemoved new 
			tabs: self; 
			page: aPage; 
			pageIndex: removedPageIndex;
			newIndex: self tabSelectorMorph selectedIndex).
	self pages isEmpty 
		ifTrue: [ self contentMorph removeAllMorphs ]! !

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 7/23/2011 20:21'!
render: aBrowser
	aBrowser panes isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	tabs announcer on: LazyTabPageChanged do: [:ann |  
		aBrowser activeEntity: ((aBrowser panes at: ann pageIndex) port: #entity) value ].
	tabs announcer on: LazyTabPageRemoved do: [:ann |  
		aBrowser removePaneIndex: ann pageIndex.
		aBrowser panes isEmpty 
				ifTrue: [aBrowser activeEntity: nil]
				ifFalse: [aBrowser activeEntity: ((aBrowser panes at: ann newIndex) port: #entity) value] ].
	aBrowser panes do: [ :each | 
		tabs 
			addLazyPage: [ GLMMorphicPaneWithoutTitleRenderer new render: each ]
			label: (self titleOrIconOf: each presentations in: tabs)
			toolbar: (self renderToolbarForPresentation: each presentations inMorph: tabs )
			collapsable: true ].
	aBrowser on: GLMPaneSelected send: #actOnPaneSelected: to: self.
	aBrowser on: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	tabs selectedPageIndex: tabs pages size.
	^ tabs! !

!GLMMorphicBrowserRenderer methodsFor: 'callbacks' stamp: 'TudorGirba 4/12/2011 12:49'!
actOnBrowserClosed: ann
	self renderer window delete! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicDashboardRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDashboardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 5/17/2011 11:07'!
firstColumnMaxCellSizeFrom: aGLMDashboard

	|tmpMaxVerticalSize tmpMaxHorizontalSize|
	tmpMaxHorizontalSize := 0.
	tmpMaxVerticalSize := 0.
	(self firstColumnPanesFrom: aGLMDashboard) do: [:aGLMPane |
		|tmpPaneExtent|
		tmpPaneExtent := aGLMDashboard extentOfPaneNamed: aGLMPane name.  
		tmpPaneExtent x > tmpMaxHorizontalSize ifTrue: [tmpMaxHorizontalSize := tmpPaneExtent x].
		tmpPaneExtent y > tmpMaxVerticalSize ifTrue: [tmpMaxVerticalSize := tmpPaneExtent y].
		].   
	^ tmpMaxHorizontalSize @ tmpMaxVerticalSize 

	
	! !

!GLMMorphicDashboardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 5/17/2011 11:31'!
firstColumnMinCellSizeFrom: aGLMDashboard

	|tmpMinVerticalSize tmpMinHorizontalSize|
	tmpMinHorizontalSize := (aGLMDashboard extentOfPaneNamed: (aGLMDashboard panes anyOne name)) x  .
	tmpMinVerticalSize :=  (aGLMDashboard extentOfPaneNamed: (aGLMDashboard panes anyOne name)) y.
	(self firstColumnPanesFrom: aGLMDashboard) do: [:aGLMPane |
		|tmpPaneExtent|
		tmpPaneExtent := aGLMDashboard extentOfPaneNamed: aGLMPane name.  
		tmpPaneExtent x < tmpMinHorizontalSize ifTrue: [tmpMinHorizontalSize := tmpPaneExtent x].
		tmpPaneExtent y < tmpMinVerticalSize ifTrue: [tmpMinVerticalSize := tmpPaneExtent y].
		].   
	^ tmpMinHorizontalSize @ tmpMinVerticalSize ! !

!GLMMorphicDashboardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 5/17/2011 11:00'!
firstColumnPanesFrom: aGLMDashboard

	|tmpHalfSizePanes tmpResult|
	aGLMDashboard panes isEmpty ifTrue: [^#()].
	tmpResult := OrderedCollection new.
	tmpHalfSizePanes := (aGLMDashboard panes size / 2) asFloat rounded.
	1 to: tmpHalfSizePanes do: [:anIndex |
		tmpResult add: (aGLMDashboard panes at: anIndex)
		].
	^ tmpResult! !

!GLMMorphicDashboardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 7/29/2011 13:47'!
render: aBrowser
	| container firstColumnContainer secondColumnContainer scrollPane panesMidSize|
	firstColumnContainer := PanelMorph new.
	secondColumnContainer := PanelMorph new.
	container := PanelMorph new.
	aBrowser defaultPaneExtent: #glamourOptimalExtent.
	firstColumnContainer  
		fillStyle: Color transparent;
		fillStyle: Color transparent;
		changeTableLayout;
		cellPositioning: #topRight;
		layoutInset: 2;
		"maxCellSize: (self firstColumnMaxCellSizeFrom: aBrowser) ;"
		"minCellSize: 20@20 ;"
		cellInset: 2.
		
	secondColumnContainer   
		fillStyle: Color transparent;
		changeTableLayout;
		cellPositioning: #topLeft; 
		layoutInset: 2;
		"maxCellSize: (self secondColumnMaxCellSizeFrom: aBrowser) ;"
		"minCellSize: (self secondColumnMaxCellSizeFrom: aBrowser);"
		cellInset: 2.
		
	container   
		fillStyle: Color transparent;
		changeTableLayout;
		extent: 200@200;
		layoutInset: 2;
		cellPositioning: #topLeft;
		"maxCellSize: 400@200;
		minCellSize: 400@150;"
		listDirection: #leftToRight;
		cellInset: 2.
	
	aBrowser extentStrategy initializeContainer: container.
	aBrowser extentStrategy initializeFirstColumn: firstColumnContainer.
	aBrowser extentStrategy initializeSecondColumn: secondColumnContainer.
	scrollPane := GeneralScrollPane new.
	scrollPane 
		changeScrollerTableLayout;
		scrollTarget: container.
		
	(self firstColumnPanesFrom: aBrowser) reverseDo: [:aGLMPane |
		self renderPane: aGLMPane inUI: firstColumnContainer  from: aBrowser.
		].  
	(self secondColumnPanesFrom: aBrowser) reverseDo: [:aGLMPane |
		self renderPane: aGLMPane inUI: secondColumnContainer  from: aBrowser
		].
	
	container addMorph: secondColumnContainer.
	container addMorph: firstColumnContainer.
	
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ scrollPane! !

!GLMMorphicDashboardRenderer methodsFor: 'private' stamp: 'cyrilledelaunay 6/7/2011 10:33'!
renderPane: aPane inUI: aMorph from: aGLMDashboard

	| pane totalSpans currentSpanPosition currentOffset tmpExtent|
	pane := self renderObject: (aPane). 
	"pane
		hResizing: #rigid;
		vResizing: #rigid."
	
	
	"self haltIf: [aPane name = #dashboard]."
	"pane extent: (aGLMDashboard extentOfPaneNamed: aPane name). "
	aGLMDashboard extentStrategy initializePane: pane.
	pane extent: ((aGLMDashboard extentOfPaneNamed: aPane name) moValue: pane). 
	"self haltIf: [pane submorphs contains: [:a | a isKindOf: GeneralScrollPane]]."
	aMorph addMorph: pane.
! !

!GLMMorphicDashboardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 5/17/2011 11:08'!
secondColumnMaxCellSizeFrom: aGLMDashboard

	|tmpMaxVerticalSize tmpMaxHorizontalSize|
	tmpMaxHorizontalSize := 0.
	tmpMaxVerticalSize := 0.
	(self secondColumnPanesFrom: aGLMDashboard) do: [:aGLMPane |
		|tmpPaneExtent|
		tmpPaneExtent := aGLMDashboard extentOfPaneNamed: aGLMPane name.  
		tmpPaneExtent x > tmpMaxHorizontalSize ifTrue: [tmpMaxHorizontalSize := tmpPaneExtent x].
		tmpPaneExtent y > tmpMaxVerticalSize ifTrue: [tmpMaxVerticalSize := tmpPaneExtent y].
		].   
	^ tmpMaxHorizontalSize @ tmpMaxVerticalSize ! !

!GLMMorphicDashboardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 5/17/2011 11:32'!
secondColumnMinCellSizeFrom: aGLMDashboard

	|tmpMinVerticalSize tmpMinHorizontalSize|
	tmpMinHorizontalSize := (aGLMDashboard extentOfPaneNamed: (aGLMDashboard panes anyOne name)) x  .
	tmpMinVerticalSize :=  (aGLMDashboard extentOfPaneNamed: (aGLMDashboard panes anyOne name)) y.
	(self secondColumnPanesFrom: aGLMDashboard) do: [:aGLMPane |
		|tmpPaneExtent|
		tmpPaneExtent := aGLMDashboard extentOfPaneNamed: aGLMPane name.  
		tmpPaneExtent x < tmpMinHorizontalSize ifTrue: [tmpMinHorizontalSize := tmpPaneExtent x].
		tmpPaneExtent y < tmpMinVerticalSize ifTrue: [tmpMinVerticalSize := tmpPaneExtent y].
		].   
	^ tmpMinHorizontalSize @ tmpMinVerticalSize ! !

!GLMMorphicDashboardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 5/17/2011 11:42'!
secondColumnPanesFrom: aGLMDashboard

	|tmpHalfSizePanes tmpResult|
	aGLMDashboard panes isEmpty ifTrue: [^#()].
	tmpResult := OrderedCollection new.
	tmpHalfSizePanes := (aGLMDashboard panes size / 2) asFloat rounded.
	(tmpHalfSizePanes + 1) to: aGLMDashboard panes size do: [:anIndex |
		tmpResult add: (aGLMDashboard panes at: anIndex)
		].
	^ tmpResult! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicDropDownRenderer
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDropDownRenderer methodsFor: 'as yet unclassified' stamp: 'TudorGirba 6/29/2012 09:47'!
render: aDropListPresentation
	| listModel |

	listModel:= GLMDropListModel new glamourPresentation: aDropListPresentation.
	"When the morph changes, we want to update the glamour model"
	listModel announcer on: GLMDropDownListMorphSelectionChanged do: [ :ann | 	
		aDropListPresentation selection: ann selectionValue ].
	listModel selectionIndex: aDropListPresentation selectedIndex.
	^(MorphDropListMorph
			on: listModel
			list: #list
			selected: #selectionIndex
			changeSelected: #selectionIndex:
			useIndex: true )
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicExpanderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/26/2012 10:47'!
render: aBrowser
	^ self renderWithExpanders: aBrowser   ! !

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 3/9/2011 10:20'!
renderWithExpanders: aBrowser
	| morph scroll panel expander |
	panel := PanelMorph new.
	panel 
		fillStyle: Color transparent;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		changeTableLayout;
		layoutInset: 2;
		cellInset: 2.
	scroll := GeneralScrollPane new.
	scroll 
		changeScrollerTableLayout;
		scrollTarget: panel.
	aBrowser panes do: [:each |
		expander := ExpanderMorph titleText: (each presentations titleValue ifNil: ['noname']).
		morph := GLMMorphicPaneWithoutTitleRenderer new render: each.
		morph 
			borderStyle: (UITheme current buttonSelectedBorderStyleFor: morph).
		expander addMorphBack: morph.
		panel addMorph: expander	].
	^ scroll! !

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 2/13/2012 13:18'!
renderWithTree: aBrowser
	| treeMorph treeModel |
	treeModel := GLMExpanderTreeMorphModel new glamourExpander: aBrowser.
	treeMorph := MorphTreeMorph new.
	treeMorph
		makeLastColumnUnbounded;
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		cornerStyle: treeMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		preferedPaneColor: Color white;	
		model: treeModel;
		columns: ( OrderedCollection with: (MorphTreeColumn new rowMorphGetSelector: #elementColumn)).
	treeMorph vShowScrollBar.
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ treeMorph buildContents! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicFinderRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneAdded: ann
	self subclassResponsibility! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
actOnPaneRemoved: ann
	self subclassResponsibility! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
actOnPaneReplaced: ann
	self subclassResponsibility! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:49'!
registerAnnouncementsFor: aBrowser
	aBrowser 
		on: GLMPaneRemoved send: #actOnPaneRemoved: to: self.
	aBrowser 
		on: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser 
		on: GLMPaneReplaced send: #actOnPaneReplaced: to: self.
	aBrowser 
		on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:09'!
render: aBrowser
	^ self subclassResponsibility! !

GLMMorphicFinderRenderer subclass: #GLMMorphicFixedPanesFinderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneAdded: ann
	container pushPane: (self renderObject: ann pane)! !

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneRemoved: ann
	container popPane! !

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneReplaced: ann
	container popAndReplacePane: (self renderObject: ann newPane)! !

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
render: aBrowser
	container := GLMPaneScroller new
		name: 'scroller';
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.
	container maxPanes: aBrowser fixedSizePanes.
	self registerAnnouncementsFor: aBrowser.  
	aBrowser panes
		do: [ :each | container pushPane: (self renderObject: each) ].
	^ container! !

GLMMorphicFinderRenderer subclass: #GLMMorphicVariablePanesFinderRenderer
	instanceVariableNames: 'scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:12'!
actOnPaneAdded: ann
	self addMorphFromObject: ann pane toContainer: container.
	scrollPane hScrollbar glmAnimateValue: 1.0 duration: 2000! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:12'!
actOnPaneRemoved: ann
	container removeMorph: container submorphs last.
	container removeMorph: container submorphs last! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:13'!
actOnPaneReplaced: ann
	container removeMorph: container submorphs last.
	container removeMorph: container submorphs last.
	self addMorphFromObject: ann newPane toContainer: container.
	scrollPane hScrollbar glmAnimateValue: 1.0 duration: 200! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
addMorphFromObject: anObject toContainer: aContainerMorph
	| renderedMorph |
	renderedMorph := (self renderObject: anObject)
				vResizing: #spaceFill;
				hResizing: #rigid;
				minimumExtent: 200@10;
				extent: 200@10;
				yourself.
	aContainerMorph addMorphBack: renderedMorph.
	aContainerMorph addMorphBack: (EdgeGripMorph new
		width: ProportionalSplitterMorph splitterWidth;
		hResizing: #rigid; "not the default this time, vResizing is also #spaceFill by default"
		target: renderedMorph)! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:13'!
render: aBrowser
	container := GLMMorphic containerMorph.
	container 
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap.
	scrollPane := GeneralScrollPane new
		changeScrollerTableLayout;
		scrollTarget: container;
		yourself.
	self registerAnnouncementsFor: aBrowser.  
	aBrowser panes do: [ :each | self addMorphFromObject: each toContainer: container ].
	^ scrollPane! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicStackerRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicStackerRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:49'!
render: aBrowser
	| tabs |
	aBrowser panes isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	aBrowser panes do: [ :each | 
		self flag: 'add toolbar'.
		tabs 
			addLazyPage: [ GLMMorphicPaneWithoutTitleRenderer new render: each ]
			label: (self titleOrIconOf: each presentations in: tabs)
			toolbar: (self renderToolbarForPresentation: each presentations inMorph: tabs) ].
	tabs selectedPageIndex: 1.
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ tabs! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicTabulatorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTabulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:49'!
render: aBrowser
	| container |
	container := GLMMorphic containerMorph.
	aBrowser cell isRow 
		ifTrue: 
			[ self 
				renderCustomRow: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ]
		ifFalse: 
			[ self 
				renderCustomColumn: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ].
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ container! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'TudorGirba 1/20/2011 21:53'!
renderCustomColumn: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId 
			ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
			ifFalse: [ 
				self 
					renderCustomRow: each
					ofPane: aPane
					inUI: (pane := GLMMorphic containerMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
					topFraction: currentSpanPosition / totalSpans offset: currentOffset + 2;
					leftFraction: 0 offset: 0;
					bottomFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - 2;
					rightFraction: 1 offset: 0;
					yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	(aCell children last size > 0) ifTrue: [
		(aMorph submorphs atLast: 2) layoutFrame bottomOffset: (aMorph submorphs atLast: 2) layoutFrame bottomOffset - aCell children last size. 
		aMorph submorphs last layoutFrame topOffset: aMorph submorphs last layoutFrame topOffset - aCell children last size. 
		aMorph submorphs last layoutFrame bottomOffset: aMorph submorphs last layoutFrame bottomOffset - aCell children last size.].
	aMorph addPaneSplitters! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'TudorGirba 1/20/2011 21:53'!
renderCustomRow: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId 
			ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
			ifFalse: [ self 
					renderCustomColumn: each
					ofPane: aPane
					inUI: (pane := GLMMorphic containerMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
				topFraction: 0 offset: 0;
				leftFraction: currentSpanPosition / totalSpans offset: currentOffset + 2;
				bottomFraction: 1 offset: 0;
				rightFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - 2;
				yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	(aCell children last size > 0) ifTrue: [
		(aMorph submorphs atLast: 2) layoutFrame rightOffset: (aMorph submorphs atLast: 2) layoutFrame rightOffset - aCell children last size. 
		aMorph submorphs last layoutFrame leftOffset: aMorph submorphs last layoutFrame leftOffset - aCell children last size. 
		aMorph submorphs last layoutFrame rightOffset: aMorph submorphs last layoutFrame rightOffset - aCell children last size.].
	aMorph addPaneSplitters! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicValidatorRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicValidatorRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 5/5/2011 12:10'!
render: aBrowser

	|tmpButtons|
	tmpButtons := OrderedCollection new.
	aBrowser panes isEmpty ifTrue: [ 
		"|tmpPane|
		tmpPane := (GLMPane in: aBrowser) 
				addPresentation: aBrowser presentations; 
				yourself.	
		(tmpPane port: #entity) value: aBrowser entity.	
		aBrowser panes add: tmpPane"
			].
	aBrowser buttonActions do: [:aGLMAction |
		|buttonModel|
		buttonModel := GLMButtonModel new.
		buttonModel glamourPresentation: aBrowser.
		buttonModel glamourAction: aGLMAction.
		tmpButtons add: (PluggableButtonMorph 
			on: buttonModel
			getState: nil
			action: #execute
			label: #buttonLabel)
		].
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	container := (GLMMorphicValidatorPaneRenderer new buttons: tmpButtons; render: aBrowser panes anyOne).
	^ container
	! !

!GLMMorphicValidatorRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 13:25'!
render: aBrowser from: aGLMRenderer

	self renderer: aGLMRenderer.
	^ self render: aBrowser
	! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicWizardRenderer
	instanceVariableNames: 'scrollPane container parentRenderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/4/2011 14:52'!
actOnPaneAdded: ann
	container removeMorph: container submorphs last.
	self addMorphFromObject: ann pane toContainer: container.! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/4/2011 15:53'!
actOnPaneRemoved: ann! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/31/2011 16:33'!
actOnPaneReplaced: ann

	container removeMorph: container submorphs last.
	self addMorphFromObject: ann newPane toContainer: container.
	"scrollPane hScrollbar glmAnimateValue: 1.0 duration: 200"! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/31/2011 17:25'!
addMorphFromObject: anObject toContainer: aContainerMorph

	| renderedMorph |
	renderedMorph := (self renderObject: anObject).
				"vResizing: #spaceFill;
				hResizing: #rigid;
				minimumExtent: 200@10;
				extent: 200@10;
				yourself."
	aContainerMorph addMorphBack: renderedMorph.! !

!GLMMorphicWizardRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 4/1/2011 14:16'!
parentRenderer

	^ parentRenderer! !

!GLMMorphicWizardRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 4/1/2011 14:17'!
parentRenderer: aGLMMorphicRenderer

	parentRenderer := aGLMMorphicRenderer! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 12:50'!
registerAnnouncementsFor: aBrowser
	aBrowser 
		on: GLMPaneRemoved send: #actOnPaneRemoved: to: self.
	aBrowser 
		on: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser 
		on: GLMPaneReplaced send: #actOnPaneReplaced: to: self.
	aBrowser 
		on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/4/2011 16:43'!
render: aBrowser
	container := GLMMorphic containerMorph.
	container
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	scrollPane := GeneralScrollPane new
		changeScrollerTableLayout;
		scrollTarget: container;
		yourself.
	self registerAnnouncementsFor: aBrowser.  
	self addMorphFromObject: (aBrowser stepsAndPanes at: aBrowser currentStep) last toContainer: container .
	^ scrollPane! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicWrapperRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWrapperRenderer methodsFor: 'rendering' stamp: 'TudorGirba 5/18/2012 22:38'!
render: aBrowser
	| paneMorph |
	container := GLMMorphic containerMorph.
	
	paneMorph := self renderObject: aBrowser defaultPane.
	paneMorph layoutFrame: (LayoutFrame fractions: (0@0 corner: 1@1)).
	container addMorphBack: paneMorph.	
	
	aBrowser on: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ container ! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicCompositeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicCompositeRenderer subclass: #GLMMorphicAccordionRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAccordionRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/31/2011 02:12'!
render: aPresentation
	| presentations container expander |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	presentations size = 1 ifTrue: [ ^ self renderWithToolbar: presentations first ].
	container := GLMMorphic containerMorph.
	container changeTableLayout.
	presentations do: [ :each | 
		expander := self theme 
			newExpanderIn: container 
			label: (self titleOrIconOf: each in: container)
			forAll: {(self renderWithToolbar: each)}.
		container addMorphBack: expander.
		(aPresentation pane lastActivePresentation notNil and: [
			each title = aPresentation pane lastActivePresentation title ]) ifTrue: [
				expander expanded: true]].
	(aPresentation pane lastActivePresentation isNil and: [container submorphs notEmpty]) ifTrue: [
		container submorphs first expanded: true].
	^ container! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicTabbedRenderer
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 11/3/2011 17:40'!
actOnPresentationUpdated: ann
	| index presentations |
	presentations := ann presentation matchingPresentations.
	tabs pages size to: 1 by: -1 do: [ :i | tabs removePageIndex: i ].	
	presentations do: [ :each | 
		tabs 
			addLazyPage: [ self renderObject: each ]
			label: (self titleOrIconOf: each in: tabs)
			toolbar: (self renderToolbarForPresentation: each inMorph: tabs ) ].
	index := 1.
	presentations withIndexDo: [ :each :i | 
		ann presentation pane lastActivePresentation notNil and: [ 
			each title = ann presentation pane lastActivePresentation title ifTrue: [ 
				index := i ] ] ].
	tabs selectedPageIndex: index.! !

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'TudorGirba 5/21/2012 05:10'!
render: aPresentation

	| presentations index |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	(presentations size = 1 and: [ presentations first hasTitleIcon not ])
		ifTrue: [ ^ self renderWithTitleOrNil: presentations first ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme buttonFont.
	tabs announcer when: LazyTabPageChanged do: [:ann |
		aPresentation pane lastActivePresentation: (aPresentation matchingPresentations at: (ann pageIndex)) ].
	presentations do: [ :each | 
		tabs 
			addLazyPage: [ self renderObject: each ]
			label: (self titleOrIconOf: each in: tabs)
			toolbar: (self renderToolbarForPresentation: each inMorph: tabs ) ].
	index := 1.
	presentations withIndexDo: [ :each :i | 
		(aPresentation pane isLastActivePresentation: each) 
			ifTrue: [ index := i ] ].
	tabs selectedPageIndex: index.
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.

	^ tabs! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicVerticallyStackedRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicVerticallyStackedRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:55'!
render: aPresentation
	| presentations container |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].	
	container := GLMMorphic containerMorph.
	container changeTableLayout.
	presentations do: [ :each | 
		container addMorphBack: (self renderWithTitle: each) ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicDiffRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDiffRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/4/2011 18:16'!
render: aPresentation
	| textMorph |
	textMorph := (DiffMorph from: aPresentation displayValue first to: aPresentation displayValue last)
"			onKeyStrokeSend: #keystroke:from: to: textModel;
"			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			color: Color white;
			yourself.
"	self installActionsOnUI: textModel fromPresentation: aTextPresentation.
	aTextPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aTextPresentation textBlock: [ textMorph textMorph editor text ].
"	^textMorph! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicDynamicRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDynamicRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 10:54'!
actOnPresentationUpdated: anAnnouncement
	container removeAllMorphs.
	container 
		addMorph: (self renderObject: anAnnouncement presentation currentPresentation) 
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)) ! !

!GLMMorphicDynamicRenderer methodsFor: 'rendering' stamp: 'TudorGirba 5/21/2012 05:17'!
render: aPresentation
	container := GLMMorphic containerMorph.
	container 
		addMorph: (self renderObject: aPresentation currentPresentation) 
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicEyeSeeRenderer
	instanceVariableNames: 'canvasScrollPane eyeseeCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicEyeSeeRenderer methodsFor: 'private' stamp: 'TudorGirba 4/12/2011 11:28'!
actOnContextChanged: ann
	"ann property = #selection ifTrue: [ 
		eyeseeCanvas selected: (eyeseeCanvas root deepFindNodeWithEntity: ann value) ]"! !

!GLMMorphicEyeSeeRenderer methodsFor: 'private' stamp: 'TudorGirba 4/12/2011 11:08'!
actOnPresentationUpdate: ann
	ann presentation diagram: ESDiagramRenderer new.
	canvasScrollPane scroller removeMorph: canvasScrollPane scroller submorphs first.
	self eyeseeCanvasFor: ann presentation! !

!GLMMorphicEyeSeeRenderer methodsFor: 'private' stamp: 'TudorGirba 4/19/2011 13:34'!
eyeseeCanvasFor: aPresentation
	| eyeseeRenderer |
	eyeseeRenderer := aPresentation eyeseeRenderer.
	aPresentation renderOn: eyeseeRenderer.
	eyeseeRenderer interaction 
			when: ESElementSelection
			do: [ :ann | aPresentation selection: ann element ].
	eyeseeRenderer interaction 
			when: ESElementDeselection
			do: [ :ann | aPresentation status: ann element ].
	eyeseeRenderer interaction 
			when: ESMouseLeave
			do: [ :ann | aPresentation status: nil ].
	eyeseeCanvas := aPresentation canvas.
	canvasScrollPane scroller addMorph: eyeseeCanvas! !

!GLMMorphicEyeSeeRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 10:25'!
render: aPresentation
	canvasScrollPane := ScrollPane new.
	self eyeseeCanvasFor: aPresentation.
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	^ canvasScrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicLabelRenderer
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicLabelRenderer methodsFor: 'rendering' stamp: 'TudorGirba 7/1/2011 23:18'!
actOnPresentationUpdated: anAnnouncement
	labelMorph contents: anAnnouncement presentation formatedDisplayValue! !

!GLMMorphicLabelRenderer methodsFor: 'rendering' stamp: 'TudorGirba 7/1/2011 23:16'!
render: aLabelPresentation
	labelMorph := (LabelMorph contents: aLabelPresentation formatedDisplayValue) 
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			font: StandardFonts haloFont;
			yourself.
	aLabelPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^labelMorph! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicListingRenderer
	instanceVariableNames: 'treeMorph treeModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicListingRenderer subclass: #GLMMorphicListRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 10:47'!
actOnContextChanged: anAnnouncement 
	anAnnouncement property = #selection ifTrue: [ 
		treeModel announcer suspendAllWhile: [
			treeMorph model explicitSelection: anAnnouncement value ] ] ! !

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/20/2012 15:18'!
actOnUpdatedPresentation: anAnnouncement
	treeMorph model updateRoots.
	self flag: 'Calling update list explicitly here is a hack. This should be solvable by the model through a notification mechanism'.
	treeMorph updateList! !

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'TudorGirba 10/31/2011 11:25'!
render: aPresentation
	| container textInput |
	treeModel := GLMTreeMorphModel new glamourPresentation: aPresentation.
	container := GLMMorphic containerMorph.
	treeMorph := self treeMorphFor: treeModel and: aPresentation.
	aPresentation allowsInput ifTrue: [
		textInput := self textInputFor: treeModel withHelpMessage: aPresentation helpMessage.
		treeMorph layoutFrame bottomOffset: -24.
		container addMorphBack: textInput ].
	container addMorphBack: treeMorph.
	self installActionsOnUI: treeModel fromPresentation: aPresentation.

	aPresentation selection notNil ifTrue: [
		treeModel announcer suspendAllWhile: [
			treeMorph model explicitSelection: aPresentation selection ]].

	"When the morph changes, we want to update the glamour model"
	treeModel announcer on: GLMTreeMorphSelectionChanged do: [ :ann | 
		aPresentation announcer suspendAllWhile: [
			aPresentation selection: ann selectionValue.
			aPresentation selectionPath: ann selectionPathValue] ].
	treeModel announcer on: GLMTreeMorphStrongSelectionChanged do: [ :ann | 
		aPresentation strongSelection: ann strongSelectionValue ].
	
	"When the glamour model changes, we want to update the morph"
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	aPresentation on: GLMPresentationUpdated send: #actOnUpdatedPresentation: to: self.

	^ container! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'TudorGirba 5/18/2011 18:31'!
textInputFor:  aTreeModel withHelpMessage: helpStringMessage
	| textInput |
	textInput := self theme 
			newTextEntryIn: nil
			for: aTreeModel
			get: #inputText
			set: #inputText:
			class: String
			getEnabled: #inputTextEnabled
			help: helpStringMessage.
	textInput askBeforeDiscardingEdits: false.
	textInput layoutFrame: (LayoutFrame 
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0 @ -24 corner: 0 @ 0)).
	^ textInput! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'TudorGirba 9/24/2012 22:33'!
treeMorphFor: tmpTreeModel and: aPresentation
	| tmpTreeMorph columns |
	tmpTreeMorph := PaginatedMorphTreeMorph new.
	tmpTreeMorph
		makeLastColumnUnbounded;
		doubleClickSelector: #onDoubleClick;
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		cornerStyle: tmpTreeMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		autoDeselection: aPresentation allowsDeselection;
		dragEnabled: tmpTreeModel dragEnabled;
		dropEnabled: tmpTreeModel dropEnabled;		
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	columns := aPresentation columns isEmpty 
		ifTrue: [ OrderedCollection with: (MorphTreeColumn new rowMorphGetSelector: #elementColumn)]
		ifFalse: [
			aPresentation columns collect: [:each | 
				GLMMorphTreeColumn new 
					startWidth: each width;
					glamourColumn: each; 
					headerButtonLabel: (aPresentation titleValueOfColumn: each)
					font: StandardFonts menuFont 
					target: nil 
					actionSelector: nil 
					arguments: #(); 
					yourself ].
		].
	tmpTreeMorph
		preferedPaneColor: Color white;	
		model: tmpTreeModel;
		columns: columns.
	aPresentation isMultiple 
		ifTrue: [tmpTreeMorph beMultiple] 
		ifFalse: [tmpTreeMorph beSingle].
	tmpTreeMorph chunkSize: aPresentation amountToShow.
	tmpTreeMorph pageSize: aPresentation amountToShow.
	tmpTreeMorph vShowScrollBar.
	^ tmpTreeMorph buildContents! !

GLMMorphicListingRenderer subclass: #GLMMorphicTableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicListingRenderer subclass: #GLMMorphicTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTreeRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 23:18'!
render: aPresentation
	| container |
	container := super render: aPresentation.
	aPresentation shouldAllExpand ifTrue: [container submorphs first expandAll ].
	aPresentation shouldRootsExpand ifTrue: [container submorphs first expandRoots ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicMagritteRenderer
	instanceVariableNames: 'scrollPane containerMorphClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/30/2011 15:54'!
actOnPresentationUpdated: ann
	scrollPane scrollTarget: (self magritteMorphFrom: ann presentation) ! !

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/16/2011 10:54'!
magritteMorphFrom: aMagrittePresentation
	| toShow description magritteMorph magritteDescriptionMorph |
	toShow := aMagrittePresentation displayValue.
	description := (aMagrittePresentation magritteDescription glamourValue: toShow) copy.
	"Using MAContainerMorph can raise some problems, as it try to delete morphs after commiting. We don't want this behavior."
	(description morphClass = MAContainerMorph)
		ifTrue: [description morphClass: MASilentContainerMorph]. 
	magritteDescriptionMorph :=  (description asMorphOn: toShow)
		onAnswer: [ :value | aMagrittePresentation reactOnAnswerFor: value ].
	magritteMorph := magritteDescriptionMorph
		addButtons;
		morph.
	magritteMorph
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		layoutChanged.
	^ magritteMorph! !

!GLMMorphicMagritteRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/21/2011 11:30'!
render: aMagrittePresentation		.
	scrollPane := GeneralScrollPane new.
	scrollPane changeScrollerTableLayout.
	scrollPane scrollTarget: (self magritteMorphFrom: aMagrittePresentation).
	scrollPane layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 25 corner: 0 @ 0)).

	aMagrittePresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ scrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicMondrianRenderer
	instanceVariableNames: 'canvasScrollPane mondrianCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicMondrianRenderer methodsFor: 'private' stamp: 'TudorGirba 2/15/2011 12:47'!
actOnContextChanged: ann
	ann property = #selection ifTrue: [ 
		mondrianCanvas selected: (mondrianCanvas root deepFindNodeWithEntity: ann value) ]! !

!GLMMorphicMondrianRenderer methodsFor: 'private' stamp: 'TudorGirba 2/15/2011 17:48'!
actOnPresentationUpdate: ann
	ann presentation view: MOViewRenderer new.
	canvasScrollPane scroller removeMorph: canvasScrollPane scroller submorphs first.
	self mondrianCanvasFor: ann presentation! !

!GLMMorphicMondrianRenderer methodsFor: 'private' stamp: 'TudorGirba 2/15/2011 17:50'!
mondrianCanvasFor: aPresentation
	| view |
	view := aPresentation view.
	view root interaction menu: [ :x | self menuIn: MenuMorph new for: aPresentation ].
	aPresentation renderOn: view.
	mondrianCanvas := aPresentation canvas.
	mondrianCanvas announcer
			when: MOElementSelection
			do: [ :ann | aPresentation selection: ann element model ].
	mondrianCanvas announcer
			when: MOMouseEnter
			do: [ :ann | aPresentation status: ann element model ].
	mondrianCanvas announcer
			when: MOMouseLeave
			do: [ :ann | aPresentation status: nil ].
	canvasScrollPane scroller addMorph: mondrianCanvas! !

!GLMMorphicMondrianRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 17:51'!
render: aPresentation
	canvasScrollPane := ScrollPane new.
	self mondrianCanvasFor: aPresentation.
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	^ canvasScrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicMorphRenderer
	instanceVariableNames: 'scrollPane containerMorphClass container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicMorphRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 11/8/2011 02:06'!
actOnKeyStroke: aPresentation event: anEvent from: aMorph 
	| action |

	anEvent commandKeyPressed ifFalse: [ ^self ].
	action := (self allKeyboardActionsFor: aPresentation) 
		detect: [ :each | each shortcut = anEvent keyCharacter  ] 
		ifNone: [ nil ].
		
	action 
		ifNotNil: [ action actOn: aPresentation].! !

!GLMMorphicMorphRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 11/7/2011 11:23'!
actOnPresentationUpdated: ann
	container removeAllMorphs.
	container addMorphBack: (self morphFrom: ann presentation)! !

!GLMMorphicMorphRenderer methodsFor: 'private' stamp: 'EstebanLorenzano 11/8/2011 00:22'!
allKeyboardActionsFor: aPresentation 
	^(aPresentation allActions, 
		aPresentation allSelectionActions) 
		select: [ :action | action hasShortcut ]! !

!GLMMorphicMorphRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 11/8/2011 00:22'!
morphFrom: aMorphPresentation
	| morph allActions |
	
	morph := aMorphPresentation displayValue 
		vResizing: #spaceFill; 
		hResizing: #spaceFill;
		yourself.
	
	(self allKeyboardActionsFor: aMorphPresentation) ifNotEmpty: [
		morph 
			on: #keyStroke 
			send: #actOnKeyStroke:event:from: 
			to: self 
			withValue: aMorphPresentation ].
		
	^morph! !

!GLMMorphicMorphRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 11/7/2011 23:46'!
render: aMorphPresentation		.
	container := GLMMorphic containerMorph.
	container 
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	
	container addMorphBack: (self morphFrom: aMorphPresentation).
	
	aMorphPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.

	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicPaneRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'TudorGirba 10/8/2011 15:07'!
actOnMatchingPresentationChanged: anAnnouncement 
	container removeAllMorphs.
	self renderContainerFor: anAnnouncement pane.
	self renderer window isNil ifFalse: [ 
		self flag: 'this check is fishy'.
		self renderer window fullBounds]! !

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:06'!
render: aPane
	container := GLMMorphic containerMorph.
	self renderContainerFor: aPane.
	aPane on: GLMMatchingPresentationsChanged send: #actOnMatchingPresentationChanged: to: self.
	^ container! !

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'TudorGirba 5/28/2012 00:25'!
renderContainerFor: aPane
	container
		addMorph: (self renderWithTitleOrNil: aPane presentations) fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		adoptPaneColor: Color transparent! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicPaneWithoutTitleRenderer
	instanceVariableNames: 'container paneMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPaneWithoutTitleRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:31'!
actOnMatchingPresentationsChanged: anAnnouncement 
	paneMorph	removeAllMorphs.
	self renderMorphFor: anAnnouncement pane.
	self renderer window fullBounds! !

!GLMMorphicPaneWithoutTitleRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:29'!
render: aPane
	paneMorph := GLMMorphic containerMorph.
	aPane
		on: GLMMatchingPresentationsChanged
		send: #actOnMatchingPresentationsChanged:
		to: self.
	self renderMorphFor: aPane.
	^ paneMorph! !

!GLMMorphicPaneWithoutTitleRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:29'!
renderMorphFor: aPane
	paneMorph
		addMorph: (self renderObject: aPane presentations) fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		adoptPaneColor: paneMorph paneColor! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicRoassalRenderer
	instanceVariableNames: 'myMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicRoassalRenderer methodsFor: 'rendering' stamp: 'usmanbhatti 6/30/2012 22:17'!
actOnPresentationUpdate: ann
	| aView |
	aView := ROMondrianViewBuilder new.
	ann presentation renderOn: aView.
	myMorph setView: aView stack.! !

!GLMMorphicRoassalRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/9/2012 21:07'!
render: aRoassalPresentation
	| view |
	view := aRoassalPresentation view.
	aRoassalPresentation renderOn: view.
	aRoassalPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	myMorph := ROMorph on: view stack. 
	^ myMorph ! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicTextRenderer
	instanceVariableNames: 'textModel textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicTextRenderer subclass: #GLMMorphicSmalltalkCodeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/20/2011 23:44'!
textModelFor: aPresentation
	| tm |
	tm := GLMSmalltalkCodeModel new
		text: aPresentation formatedDisplayValue;
		glamourPresentation: aPresentation;
		highlightSmalltalk: true;
		highlightSmalltalkContext: aPresentation highlightSmalltalkContext.
	aPresentation variableBindings do: [ :each | tm addVariableBinding: each ].
	^ tm! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'rendering' stamp: 'TudorGirba 12/3/2011 10:08'!
textMorphForModel: aTextModel
	| morph  |
	morph := GLMPluggableTextMorph new.
	morph styler workspace: aTextModel.
	morph
		on: aTextModel
			text: #text
			accept: #accept:notifying:
			readSelection: #selection
			menu: #menu:shifted:;
		autoAccept: true;
		onKeyStrokeSend: #keystroke:from: to: aTextModel;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: Color white;
		yourself.
	^ morph! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/27/2012 22:37'!
actOnContextChanged: ann 
	ann property = #selectionInterval
		ifTrue: [ 
			textMorph setSelection: ann value ]! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:20'!
actOnPresentationUpdated: ann 
	textModel text: ann presentation formatedDisplayValue.
	textModel changed: #text! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 7/29/2012 11:11'!
render: aPresentation
	textModel := self textModelFor: aPresentation.
	textMorph := self textMorphForModel: textModel.
	
	"this is a horrible hack: 
	because we cannot get the update of when the text changes from the morph,
	we get the reference to the mutable text object :) :)"
	textModel text: textMorph text.
	self installActionsOnUI: textModel fromPresentation: aPresentation.
	textMorph announcer
		on: GLMSelectedTextChanged
		do: [ :ann | 
			aPresentation announcer
				suspendAllWhile: [ 
					aPresentation selectionInterval: ann interval.
					aPresentation selectedText: ann selectedText ] ].
	textMorph announcer 
		on: GLMTextChanged 
		do: [:ann | 
			aPresentation suspendAllWhile: [ aPresentation text: ann text ] ].
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	^ textMorph! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/20/2011 23:39'!
textModelFor: aPresentation
	^ GLMTextModel new
		text: aPresentation formatedDisplayValue;
		glamourPresentation: aPresentation! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 12/3/2011 10:07'!
textMorphForModel:  aTextModel
	^ (GLMPluggableTextMorph
		on: aTextModel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
		autoAccept: true;
		onKeyStrokeSend: #keystroke:from: to: aTextModel;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: Color white;
		yourself! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicValidatorPaneRenderer
	instanceVariableNames: 'container paneMorph buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 14:06'!
actOnMatchingPresentationsChanged: anAnnouncement 
	paneMorph	removeAllMorphs.
	self renderMorphFor: anAnnouncement pane.
	self renderer window fullBounds! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 14:07'!
buttonRowFrom: aCollectionOfButtons
	"Answer a new ok/cancel button row."

	|answer buttons e|
	buttons := aCollectionOfButtons.
	e := 0@0.
	buttons do: [:b | e := e max: b minExtent].
	buttons do: [:b | b extent: e].
	answer := Morph new
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #leftToRight;
		listCentering: #bottomRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	buttons do: [:b | answer addMorphBack: b].
	^answer

	! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/23/2011 14:11'!
buttons

	^ buttons! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/23/2011 14:12'!
buttons: aCollectionOfButtons

	buttons := aCollectionOfButtons! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 16:39'!
newColumnWith: aCollectionOfMorphElements
	"use this method to create a new column in your block"
	<lint: 'Utility methods' rationale: 'defined here to facilate the use of the library' author: 'cyrille.delaunay'>
	
	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 8; yourself.
	aCollectionOfMorphElements do: [:m | answer addMorphBack: m].
	^answer! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 14:14'!
render: aPane

	paneMorph := GLMMorphic containerMorph.
	aPane
		on: GLMMatchingPresentationsChanged
		send: #actOnMatchingPresentationsChanged:
		to: self.
	self renderMorphFor: aPane.
	^ paneMorph! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/31/2011 17:13'!
renderCompositiePresentation: aCompositePresentation
	
	paneMorph := GLMMorphic containerMorph.
	paneMorph
		addMorph: 
			(self newColumnWith:  { (self renderObject: aCompositePresentation).  (self buttonRowFrom: self buttons) }) 
			fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		"addMorphBack: (self buttonRowFrom: self buttons)  ;  "
		adoptPaneColor: paneMorph paneColor.
	
	^ paneMorph! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/8/2011 12:07'!
renderMorphFor: aPane

	paneMorph
		addMorph: 
			("self newColumnWith:  {" (self renderObject: aPane presentations)".  (self buttonRowFrom: self buttons) }") 
			fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0.90));
		addMorph:  (self buttonRowFrom: self buttons)
			fullFrame: (LayoutFrame fractions: (0 @ 0.93 corner: 1 @ 1));
		adoptPaneColor: paneMorph paneColor! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicWatcherRenderer
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWatcherRenderer commentStamp: '<historical>' prior: 0!
This is a special widget renderer in that it will get to render multiple panes on the same container morph provided by a unique instance of the GLMWatcherWindow.!

!GLMMorphicWatcherRenderer methodsFor: 'rendering' stamp: 'TudorGirba 5/28/2012 14:41'!
actOnMatchingPresentationsChanged: anAnnouncement
	"whenever a relevant pane changes its presentations,
	we override the contents from the GLMWatcherWindow"
	
	GLMWatcherWindow uniqueInstance 
		addContent: [ self renderObject: anAnnouncement pane presentations ]! !

!GLMMorphicWatcherRenderer methodsFor: 'rendering' stamp: 'TudorGirba 5/27/2012 01:47'!
render: aPane
	"we just register for the announcement"
	
	aPane
		on: GLMMatchingPresentationsChanged
		send: #actOnMatchingPresentationsChanged:
		to: self
	! !

!GLMMorphicWidgetRenderer classSide methodsFor: 'instance creation' stamp: 'tg 8/22/2010 20:20'!
render: aPresentation from: aRenderer
	^ self new 
		renderer: aRenderer;
		render: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'cyrilledelaunay 8/9/2011 14:03'!
installActionsOnUI: aMorphicModel fromPresentation: aPresentation	 
	aMorphicModel when: GLMMenuItemSelected do: [ :ann | ann action morphicActOn: aPresentation ].
	aMorphicModel when: GLMKeyStroke do: [ :ann | ann action actOn: aPresentation ].! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'EstebanLorenzano 4/20/2012 16:16'!
menuIn: aMenuMorph for: aPresentation
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	(aPresentation allActions select: [:each | each isMenu ]) do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: action 
			selector: #morphicActOn:
			argument: aPresentation ].
	^ aMenuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
moreToolbarActions: noIconActions on: aBrowser
	| menuMorph |
	menuMorph := MenuMorph new.
	noIconActions do: [ :each | 
		menuMorph 
				add: each title
				target: each
				selector: #actOn:
				argument: aBrowser ].
	^ menuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/23/2011 12:49'!
morph: aMorph withTitleOf: aPresentation	
	| tabs |
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	self flag: 'add a regular page instead of a lazy one'.
	self flag: 'handle the PresentationChanged announcement to update the label in the morph. 
	The problem is that at the moment I do not know how to link to the label in the tabSelectorMorph'.
	tabs 
		addLazyPage: [aMorph]
		label: (self titleOrIconOf: aPresentation in: tabs)
		toolbar: (self renderToolbarForPresentation: aPresentation inMorph: aMorph).
	tabs selectedPageIndex: 1.
	^ tabs! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:19'!
morph: aMorph withTitleOrNilOf: aPresentation
	(aPresentation hasTitle or: [aPresentation hasTitleIcon]) ifFalse: [
		"we render at least the toolbar"
		^ self morph: aMorph withToolbarOf: aPresentation ].
	^ self morph: aMorph withTitleOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:21'!
morph: aMorph withToolbarOf: aPresentation
	| container offset dock |
	aPresentation hasActions ifFalse: [ ^ aMorph ].
	container := GLMMorphic containerMorph.
	offset := 0.
	dock := self renderToolbarForPresentation: aPresentation inMorph: container.
	offset := dock minExtent y.
	container addMorph: dock fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ offset)).	
	container 
		addMorph: aMorph 
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ offset corner: 0 @ 0)).
	^ container! !

!GLMMorphicWidgetRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 20:17'!
render: aPresentation
	^ self subclassResponsibility ! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/5/2011 23:47'!
renderObject: anObject
	^ self renderer render: anObject ! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'EstebanLorenzano 4/20/2012 16:16'!
renderToolbarForPresentation: aPresentation inMorph: aMorph
	| dock tools buttons noIconActions |
	dock := aMorph theme newToolDockingBarIn: aMorph.
	buttons := (aPresentation allActions select: [:each | each isButton ]) 
		collect: [:each | 
			(each renderGlamorouslyOn: self renderer)
				arguments: { aPresentation };
				yourself ].
	noIconActions := aPresentation allActions select: #isMenu.
	tools := aMorph theme newToolbarIn: aMorph for: buttons.
	noIconActions isEmpty ifFalse: [
			| activeForm passiveForm menuButton | 
			activeForm := GLMMorphicIcons toolbarMenuForm.
			passiveForm := GLMMorphicIcons toolbarMenuInactiveForm.
			menuButton := MultistateButtonMorph new extent: activeForm extent.
			menuButton
				extent: activeForm extent;
						activeEnabledOverUpFillStyle: (ImageFillStyle form: activeForm);
						passiveEnabledOverUpFillStyle: (ImageFillStyle form: activeForm);
						activeEnabledOverDownFillStyle: (ImageFillStyle form: passiveForm);
				passiveEnabledOverDownFillStyle: (ImageFillStyle form: passiveForm);
				addUpAction: [ | menu |
						menu := self menuIn: MenuMorph new for: aPresentation.
						menu popUpEvent: self currentEvent in: aMorph world ];
				setBalloonText: 'Menu' translated.
			buttons do: [:each | dock addMorphBack: each ].
			dock addMorphBack: menuButton.
			"isEmpty ifFalse: [dock addMorphBack: tools]" ]
		ifTrue: [ dock addAllMorphs: buttons ].
	^ dock! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/28/2011 19:20'!
renderWithTitle: aPresentation
	| morph |
	morph := self renderObject: aPresentation.
	^ self morph: morph withTitleOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:19'!
renderWithTitleOrNil: aPresentation
	| morph |
	morph := self renderObject: aPresentation.
	^ self morph: morph withTitleOrNilOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:20'!
renderWithToolbar: aPresentation
	| presentationMorph |
	presentationMorph := self renderObject: aPresentation.
	^ self morph: presentationMorph withToolbarOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 23:42'!
renderer
	^ renderer ifNil: [renderer := GLMMorphicRenderer new]! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'tg 8/22/2010 20:20'!
renderer: anObject
	renderer := anObject! !

!GLMMorphicWidgetRenderer methodsFor: 'factory' stamp: 'tg 8/23/2010 00:02'!
theme
	^ UITheme current! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 8/23/2011 23:10'!
titleOrIconOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			| image |
			image := self theme 
					newImageIn: container
					form: aPresentation titleIconValue.
			aPresentation titleValue isNil ifFalse: [
				image setBalloonText: aPresentation titleValue maxLineLength: 100 ].
			image  ]
		ifFalse: [ aPresentation titleValue ifNil: [''] ]! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 4/14/2011 23:59'!
titleOrIconOrNilOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			| image |
			image := self theme 
					newImageIn: container
					form: aPresentation titleIconValue.
			aPresentation titleValue isNil ifFalse: [
				image setBalloonText: aPresentation titleValue maxLineLength: 10 ]  ]
		ifFalse: [ 
			aPresentation hasTitle 
				ifTrue: [ aPresentation titleValue ]
				ifFalse: [ nil ] ]! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicWindowRenderer
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWindowRenderer commentStamp: '<historical>' prior: 0!
This renders the top most browser or composite presentation in a window.!

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:23'!
actOnPresentationUpdated: ann
		self setLabelOf: window for: ann presentation! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'TudorGirba 10/8/2011 18:42'!
handlePotentialStatusbarFor: aRenderable
	| statusbarMorph bottomOffset |
	aRenderable hasStatusbar
		ifTrue: [ 
			statusbarMorph := GLMMorphicPaneWithoutTitleRenderer render: aRenderable statusbarPane from: self renderer.
			bottomOffset := (0 - (LabelMorph contents: 'XXX') minHeight) * 1.2.
			window
				addMorph: statusbarMorph
				fullFrame: (LayoutFrame fractions: (0 @ 1 corner: 1 @ 1) offsets: (2 @ bottomOffset corner: -2 @ 0)) ].
	^ bottomOffset! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'TudorGirba 5/28/2012 00:28'!
render: aRenderable
	| dock offset bottomOffset |
	window := GLMSystemWindow new model: aRenderable.
	self installActionsOnUI: window fromPresentation: aRenderable.
	self setLabelOf: window for: aRenderable.
	offset := 4.
	bottomOffset := 0.
	dock := self renderToolbarForPresentation: aRenderable inMorph: window.
	dock hResizing: #shrinkWrap.
	window toolbarBox: dock.
	bottomOffset := self handlePotentialStatusbarFor: aRenderable.
	window
		addMorph: (self renderObject: aRenderable)
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ offset corner: 0 @ bottomOffset)).
	self setPotentialBackgroundColorFor: aRenderable.
	
	aRenderable on: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	
	aRenderable watcherPane notNil ifTrue: [
		GLMMorphicWatcherRenderer render: aRenderable watcherPane from: self renderer ].
	
	^ window! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:06'!
setLabelOf: window for: aRenderable
	window	setLabel: (self titleFor: aRenderable).! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/11/2011 21:59'!
setPotentialBackgroundColorFor: aRenderable
	(self theme isKindOf: UIThemeWatery)
		ifFalse: [ aRenderable colorValue ifNotNil: [ window paneColor: aRenderable colorValue ] ]! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:04'!
titleFor: aRenderable
	^ aRenderable titleValue ifNil: [ 'Glamorous Browser' ]! !
